// This is CSORT.H
// Project IMARK - a support program for indexing TeX and LaTeX documents
// (C) Jan Kybic, 1993

// Main module is IMARK.CPP It contains also compile notes
// This module contains routines for czech sorting
// and defines also class CString
// currently uses Kamenicky code scheme, but can be recompiled

// disable multiple inclusions
#ifndef _CSORT_H     
#define _CSORT_H

#ifndef _STRNG_H
#include <strng.h>
#endif


extern unsigned char use_czech ;  // declared in CSORT.H
  // if use_czech==1, 'isletter', 'compare' 
  //   and CString use czech alphabet and sorting                              

char iscsletter(unsigned char c) ;     // 1 iff 'c' is a czech letter
int  cscompare(unsigned char *r,unsigned char *s) ;
                          // positive iff r>s, zero if r=s, negative iff r<s
void initcs(void) ;       // initializes czech sorting
                          // must be called before calling this module !   
                          // 'use_czech' must be set     
// the following two pointers, point to functions using english 
// or czech alphabet respectively, according to 'use_czech'
extern char (*isletter)(unsigned char c) ;
                 // similar to iscsletter
extern int  (*compare)(unsigned char *r,unsigned char *s) ;
                 // similar to cscompare

// class CString behaves almost like String from CLASSLIB except:
//   when comparing two CStrings, 'use_czech' is taken into account
//   there is a new assignment operator     (CString)=(char *)

class CString: public String
{ public:
  CString(const unsigned char *c) ;
  CString(const String&) ;
  CString& operator =(const char *) ;
  virtual int isLessThan( const Object& ) const ;
  virtual int isEqual( const Object& ) const ;
} ;

// isLessThan and isEqual are described in SORTABLE.H from CLASSLIB
// here we just call 'compare'

inline int CString::isLessThan( const Object& testString) const
{ return (*compare)((unsigned char *)theString,
            (unsigned char *)((CString&)testString).theString)<0 ;
}

inline int CString::isEqual( const Object& testString) const
{ return !(*compare)((unsigned char *)theString,
            (unsigned char *)((CString&)testString).theString) ;
}

// we use constructors from String

inline CString::CString(const unsigned char *s) :
     String((const char *)s) {} ;

inline CString::CString(const String& s) : String(s) {} ;

#endif
// End of CSORT.H
