// This is IMCLASS.H
// classes Entry and TString
// Project IMARK - a support program for indexing TeX and LaTeX documents
// (C) Jan Kybic, 1993

// Main module is IMARK.CPP. It also contains compile notes.

#ifndef _IMCLASS_H
#define _IMCLASS_H

#include <sortarry.h>
#include "csort.h"

// Class Entry is used to store pairs of strings key/value. Key is used
//  for sorting and searching and 'value' is what will be the actual argument
//  of an indexing command.
// Key and Value strings belong to Entry. Don't 'delete' them separately!

class Entry:Sortable
{public: Entry() ;          // sets key=value=""
         ~Entry() ;
         Entry(Entry& e) ;  // copy constructor
    void setkey (String& s)  ;   // set key to
     int read (istream&) ;   // reads one line from istream
                             // store first word to key and second to value.
                             // or set value="" if there isn't a second one
 virtual void printOn (ostream& ) const ;
                             // writes contents to ostream
      // comparing is done taking only key into account
 virtual int isEqual (const Object& o) const
              { return theKey->isEqual(*((Entry&)o).theKey) ; }
 virtual int isLessThan (const Object& o) const
              { return theKey->isLessThan(*((Entry&)o).theKey) ; }
      // value returns theValue or theKey if no value has been set
 String& value() { return *(char *)(*theValue) ? *theValue : *theKey ; }
 String& key() { return *theKey ; }
      // and these are required by CLASSLIB
 virtual classType isA() const { return 0;}
 virtual char *nameOf() const  { return "Entry" ;}
 virtual hashValueType hashValue() const { return 0; }


 protected: CString  *theKey,*theValue ;
} ;


// Tstring is class used to get words from TeX source file.
// if setcopyStr has been used, it copies there everything read from input one

class TString: public CString
{ public:
  TString(const char *c) ; // copy constructors
  TString(const String&) ;
  int getword() ;          // get word (consisting of letters only)
                           // returns 0 on EOF, 1 otherwise
  void setcopyStr(ostream& o) { copyStr=&o ; } ;
                           // set copy stream
  void setiStr(istream& i) { iStr=&i ; } ;
                           // set input stream
  int  getcpy() ;
                           // get one char, copying it on copyStr
  protected:
  ostream *copyStr ;
  istream *iStr ;
} ;


#endif

// End of IMCLASS.H
