// This is IMLOW.CPP
// Project IMARK - a support program for indexing TeX and LaTeX documents
// (C) Jan Kybic, 1993


#include "imlow.h"
#include "imclass.h"

#define FILELEN 80
static char file[FILELEN] ;
ListOfWords *LW ;
CString *output_extension ;
CString *index_command ;

void appendext(CString& name,char *ext)
{  char *p,*q ;

  if (strlen((char *)name)>=FILELEN)
    { cerr << "!!! ERROR: File name too long.\n" ;
      exit(1) ; }

  strcpy(file,(char *)name) ;
  for(p=file;*p;p++) ;
  for (q=p;p>file && q-p<5 ;p--)
   { if (*p=='.') return ;
     if (*p=='\\') break ;
   }
 *q='.' ; *++q=0 ; strcat(file,ext) ;
 name=file ;
}

void changeext(CString& name,char *ext)
{  char *p,*q ;

  if (strlen((char *)name)>=FILELEN)
    { cerr << "!!! ERROR: File name too long.\n" ;
      exit(1) ; }

  strcpy(file,(char *)name) ;
  for(p=file;*p;p++) ;
  for (q=p;p>file && q-p<5 ;p--)
   { if (*p=='.') { q=p ; break ; }
     if (*p=='\\') break ;
   }
 *q='.' ; *++q=0 ; strcat(file,ext) ;
 name=file ;
}

void ListOfWords :: readfrom(CString& name)
{ ifstream ifile ; Entry e,*temp_e ;
  int rep=0 ;

  checkObject(&e) ;
  appendext(name,"LW") ;
  ifile.open(name) ;
  if (ifile.fail())
       { cerr << "!!! ERROR: Can't open LW file " << name <<
         " for reading.\n" ;
         exit(1) ; }
  cerr << "Reading list of words from file "
           << name << '\n' ;
  while (e.read(ifile))
   { if (findMember((Sortable&)e)!=NOOBJECT)
      { if (!rep)
        { rep=1 ;
          cerr << "Ignoring duplicated entries in LW file.\n" ;}
      }
     else
      { temp_e=new Entry(e) ;
        checkObject(temp_e) ;
        add((Sortable&)*temp_e) ;
        }}
}

void ListOfWords :: writeto(CString& name)
{ ofstream ofile ;

  appendext(name,"LW") ;
  ofile.open(name) ;
  if (ofile.fail())
       { cerr << "!!! ERROR: Can't open LW file " << name << "for writing.\n" ;
         exit(1) ; }
  cerr << "Writing list of words to file "
           << name << '\n' ;
  printContentsOn(ofile) ;
  ofile.close() ;
  if (ofile.fail())
       { cerr << "!!! ERROR: Can't close LW file " << name << '\n' ;
         exit(1) ; }
}

void ListOfWords::makelist(CString& name)
{ ifstream ifile ;
  TString tword("") ; Entry e,*temp_e ;

  checkObject(&tword) ;
  appendext(name,"TEX") ;
  ifile.open(name) ;
  if (ifile.fail())
       { cerr << "!!! ERROR: Can't open TeX source file " << name
         << " for reading.\n" ;
         exit(1) ; }
  cerr << "Adding words from file "
           << name << " to the list.\n" ;
  tword.setiStr(ifile) ;
  while(tword.getword())
   { e.setkey(tword) ;
     if (findMember((Sortable&)e)==NOOBJECT)
      { temp_e=new Entry(e) ;
        checkObject(temp_e) ;
        add((Sortable&)*temp_e) ;
      }
   }
}

void ListOfWords::mark(CString& name)
{ ifstream src ; ofstream dst ;
  CString dstname(name) ;
  TString tword("") ; Entry e,*e_found ;

  checkObject(&tword) ; checkObject(&dstname) ;
  checkObject(&e) ;

  appendext(name,"TEX") ;
  changeext(dstname,*output_extension) ;
  if (dstname==name)
    { cerr <<
    "!!! ERROR: Input and output file names can't have the same extensions.\n"
 << "            Use option -o.\n" ;
      exit(1) ; }

  src.open(name) ;
  if (src.fail())
       { cerr << "!!! ERROR: Can't open TeX source file " << name
         << "for reading.\n" ;
         exit(1) ; }

  dst.open(dstname,ios::out | ios::trunc) ;
  if (dst.fail())
       { cerr << "!!! ERROR: Can't open output file " << name
         << " for writing.\n" ;
         exit(1) ; }

  cerr << "Processing file " << name <<
          "\n    and writing results into " << dstname << '\n' ;

  tword.setiStr(src) ;
  tword.setcopyStr(dst) ;

  while(tword.getword())
   { e.setkey(tword) ;
     if (*(Object*)(e_found=&(Entry&)findMember((Sortable&)e))!=NOOBJECT)
       dst << '\\' << *index_command << '{'
           << e_found->value() << '}' ;
   }
  dst.close() ;
  if (dst.fail())
       { cerr << "!!! ERROR: Can't close output file " << dstname << '\n' ;
         exit(1) ; }

}

